/***************************************************************
 * Name:      wx017Main.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-01-30
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef WX017MAIN_H
#define WX017MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "wx017App.h"
#include <wx/imagpng.h>
#include <wx/dcbuffer.h>
#include <wx/dcsvg.h>
#include "icono.xpm"

class wx017Frame: public wxFrame
{
    public:
        wx017Frame(wxFrame *frame, const wxString& title);
        ~wx017Frame();
    private:
        enum
        {
            idMenuQuit = 1000,
            idMenuCaps,
            idMenuJoins,
            idMenuPenStyles,
            idMenuBrushStyles,
            idMenuDrawBitmap,
            idMenuBlitBitmap,
            idMenuStretchBlitBitmap,
            idMenuIcono,
            idMenuFuentes,
            idMenuSVG,
            idMenuAbout
        };
        enum tipofuncion {
            Nada,
            Caps,
            Joins,
            PenStyles,
            BrushStyles,
            DrawBitmap,
            BlitBitmap,
            StretchBlitBitmap,
            Fuentes,
            SVG,
            Icono
        };
        tipofuncion funcion;
        void OnClose(wxCloseEvent& event);
        void OnPaint(wxPaintEvent& event);
        void OnCaps(wxCommandEvent& event);
        void OnJoins(wxCommandEvent& event);
        void OnPenStyles(wxCommandEvent& event);
        void OnBrushStyles(wxCommandEvent& event);
        void OnDrawBitmap(wxCommandEvent& event);
        void OnBlitBitmap(wxCommandEvent& event);
        void OnStretchBlitBitmap(wxCommandEvent& event);
        void OnIcono(wxCommandEvent& event);
        void OnFuentes(wxCommandEvent& event);
        void OnSVG(wxCommandEvent& event);
        void DibujaCaps(wxDC& dc);
        void DibujaJoins(wxDC& dc);
        void DibujaPenStyles(wxDC& dc);
        void DibujaBrushStyles(wxDC& dc);
        void DibujaBitmap(wxDC& dc);
        void Blit(wxDC& dc);
        void StretchBlit(wxDC& dc);
        void DibujaIcono(wxDC& dc);
        void DibujaFuentes(wxDC& dc);
        void TrataSVG(wxDC& dc);
        void DibujaSVG(wxDC& dc);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        DECLARE_EVENT_TABLE()
};


#endif // WX017MAIN_H
